;====================================================================================================================== JOYPAD
; Routines to handle joypad input

PAD_7		EQU	(17*4)
PAD_4		EQU	(18*4)
PAD_1		EQU	(19*4)
PAD_5		EQU	(6*4)
PAD_2		EQU	(7*4)
PAD_6		EQU	(2*4)
PAD_3		EQU	(3*4)

.TEXT
.68000

;------------------------------------------------------------------------------------------------------------------ joypadinit
; Clear all the joypad lists, set them to all point to an RTS

joypadinit:
	move.w	#65,d0
	lea		padlist1,a0
	lea		.rtsbranch,a1
	
.loop:
	move.l	a1,(a0)+
	dbra.w	d0,.loop
	
.rtsbranch:
	rts
	
;-------------------------------------------------------------------------------------------------------------------- readpad1
; Read joypad1
readpad1:

	; Code liberated from Atari :)

	move.l	#$f0fffffc,d1		; d1 = Joypad data mask
	moveq.l	#-1,d2			; d2 = Cumulative joypad reading

	move.l	#-1,d0
	
	move.w	#$81fe,JOYSTICK
	move.l	JOYSTICK,d0			; Read joypad, pause button, A button
	or.l		d1,d0			; Mask off unused bits
	ror.l	#4,d0
	and.l	d0,d2			; d2 = xxAPxxxx RLDUxxxx xxxxxxxx xxxxxxxx
	move.w	#$81fd,JOYSTICK
	move.l	JOYSTICK,d0			; Read *741 keys, B button
	or.l		d1,d0			; Mask off unused bits
	ror.l	#8,d0
	and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxxxxxxx xxxxxxxx
	move.w	#$81fb,JOYSTICK
	move.l	JOYSTICK,d0			; Read 2580 keys, C button
	or.l		d1,d0			; Mask off unused bits
	rol.l	#6,d0
	rol.l	#6,d0
	and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxCxxxxx 2580xxxx
	move.w	#$81f7,JOYSTICK
	move.l	JOYSTICK,d0			; Read 369# keys, Option button
	or.l		d1,d0			; Mask off unused bits
	rol.l	#8,d0
	and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== inputs active low

	
	
	moveq.l	#-1,d1
	eor.l	d2,d1			; d1 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== now inputs active high

	cmp.l	oldpad,d1
	beq.s	.debounce
	
	; Now to test what to do for those buttons
	move.l	#31,d0
	
.ploop:
	btst	d0,d1		; Check each bit in turn and run code for it
	beq.s	.notset
	lea		padlist1,a0		; List of what to do
	move.l	d0,d2
	lsl.l	#2,d2			
	add.l	d2,a0			; move a0 to point to the right element of the list
	move.l	(a0),a0
	jsr		(a0)			; branch to it
.notset:
	dbra.w	d0,.ploop

	move.l	d1,oldpad
.debounce:	
	rts
	

	
oldpad:		dc.l	0


; List of addresses to branch to for each button.
padlist1:
	rept	33
		dc.l	0
	endr

padlist2:
	rept	33
		dc.l	0
	endr
	